---
title: 'CSP: referrer'
slug: Web/HTTP/Headers/Content-Security-Policy/referrer
tags:
  - CSP
  - Content-Security-Policy
  - Directive
  - HTTP
  - Obsolete
  - Reference
  - Security
  - referrer
---
<div>{{HTTPSidebar}} {{deprecated_header}}</div>

<p>The HTTP {{HTTPHeader("Content-Security-Policy")}} (CSP) <code><strong>referrer</strong></code> directive used to specify information in the {{HTTPHeader("Referer")}} header (with a single <code>r</code> as this was a typo in the original spec) for links away from a page. This API is deprecated and removed from browsers.</p>

<div class="note">
<p>Use the {{HTTPHeader("Referrer-Policy")}} header instead.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">Content-Security-Policy: referrer &lt;referrer-policy&gt;;</pre>

<p>where <code>&lt;referrer-policy&gt;</code> can be one of the following values:</p>

<dl>
 <dt>"no-referrer"</dt>
 <dd>The {{HTTPHeader("Referer")}} header will be omitted entirely. No referrer information is sent along with requests.</dd>
 <dt>"none-when-downgrade"</dt>
 <dd>This is the user agent's default behavior if no policy is specified. The origin is sent as referrer to a-priori as-much-secure destination (HTTPS-&gt;HTTPS), but isn't sent to a less secure destination (HTTPS-&gt;HTTP).</dd>
 <dt>"origin"</dt>
 <dd>Only send the origin of the document as the referrer in all cases.<br>
 The document <code>https://example.com/page.html</code> will send the referrer <code>https://example.com/</code>.</dd>
 <dt>"origin-when-cross-origin" / "origin-when-crossorigin"</dt>
 <dd>Send a full URL when performing a same-origin request, but only send the origin of the document for other cases.</dd>
 <dt>"unsafe-url"</dt>
 <dd>Send a full URL (stripped from parameters) when performing a same-origin or cross-origin request. This policy will leak origins and paths from TLS-protected resources to insecure origins. Carefully consider the impact of this setting.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre>Content-Security-Policy: referrer "none";</pre>

<h2 id="Specifications">Specifications</h2>

<p>Not part of any specification.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("http.headers.csp.Content-Security-Policy.referrer")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPHeader("Content-Security-Policy")}}</li>
 <li>{{HTTPHeader("Referrer-Policy")}} header</li>
 <li>{{HTTPHeader("Referer")}} header</li>
</ul>
